#include <modelo.h>

/*double find_base_move(double angle_up, double angle_lo)
{
   double result1, result2, final_result, radians_up, radians_lo ;

   radians_up = (PI*angle_up)/180.0 ;
   radians_lo = (PI*angle_lo)/180.0 ;
   result1 = (UP_LEG_HEIGHT + 2*UP_LEG_JOINT_SIZE) * cos(radians_up) ;
   result2 = (LO_LEG_HEIGHT + 2*(LO_LEG_JOINT_SIZE+FOOT_JOINT_SIZE)+FOOT_HEIGHT)
             * cos(radians_lo) ;
   final_result = LEG_HEIGHT - (result1 + result2) ;

   return (- final_result) ;
}*/

double find_base_move(double langle_up, double langle_lo, double rangle_up, double rangle_lo)
{
   double result1, result2, first_result, second_result, radians_up, radians_lo ;

   radians_up = (PI*langle_up)/180.0 ;
   radians_lo = (PI*langle_lo-langle_up)/180.0 ;
   result1 = (UP_LEG_HEIGHT + 2*UP_LEG_JOINT_SIZE) * cos(radians_up) ;
   result2 = (LO_LEG_HEIGHT + 2*(LO_LEG_JOINT_SIZE+FOOT_JOINT_SIZE)+FOOT_HEIGHT)
             * cos(radians_lo) ;
   first_result = LEG_HEIGHT - (result1 + result2) ;

   radians_up = (PI*rangle_up)/180.0 ;
   radians_lo = (PI*rangle_lo-rangle_up)/180.0 ;
   result1 = (UP_LEG_HEIGHT + 2*UP_LEG_JOINT_SIZE) * cos(radians_up) ;
   result2 = (LO_LEG_HEIGHT + 2*(LO_LEG_JOINT_SIZE+FOOT_JOINT_SIZE)+FOOT_HEIGHT)
             * cos(radians_lo) ;
   second_result = LEG_HEIGHT - (result1 + result2) ;

   if (first_result <= second_result)
      return (- first_result) ;
   else
      return (- second_result) ;
}


void animate_base(void)
{
   static frames = FRAMES,
          zoom_fl = 0,
          flag = 1 ;

   float l_upleg_dif ,
      	r_upleg_dif ,
      	l_upleg_add ,
      	r_upleg_add ,
      	l_loleg_dif ,
      	r_loleg_dif ,
      	l_loleg_add ,
      	r_loleg_add ;

   switch (flag)
   {
      case 1 :
         l_upleg_dif = 15 ;
         r_upleg_dif = 5 ;
         l_loleg_dif = 15 ;
         r_loleg_dif = 5 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

       	walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  -= l_upleg_add ;
         langle_count2 -= l_loleg_add ;
         rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 2 ;
            frames = FRAMES ;
         }
         break ;
      case 2 :
         l_upleg_dif = 20 ;
         r_upleg_dif = -65 ;
         l_loleg_dif = -15 ;
         r_loleg_dif = 85 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

         walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  -= l_upleg_add ;
         langle_count2 -= l_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
         base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 3 ;
            frames = FRAMES ;
         }
         break ;
      case 3 :
         l_upleg_dif = 5 ;
         r_upleg_dif = -25 ;
         l_loleg_dif = 10 ;
         r_loleg_dif = -40 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

         walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  -= l_upleg_add ;
         langle_count2 -= l_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 4 ;
            frames = FRAMES ;
         }
         break ;
      case 4 :
         l_upleg_dif = 20 ;
         r_upleg_dif = 25 ;
         l_loleg_dif = -10 ;
         r_loleg_dif = -50 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

         walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  -= l_upleg_add ;
         langle_count2 -= l_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 5 ;
            frames = FRAMES ;
         }
         break ;
		case 5 :
         l_upleg_dif = 5 ;
         r_upleg_dif = 15 ;
         l_loleg_dif = 5 ;
         r_loleg_dif = 15 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

       	walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  += r_upleg_add ;
         langle_count2 += r_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 6 ;
            frames = FRAMES ;
         }
         break ;
      case 6 :
         l_upleg_dif = -65 ;
         r_upleg_dif = 20 ;
         l_loleg_dif = 85 ;
         r_loleg_dif = -15 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

         walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  += r_upleg_add ;
         langle_count2 += r_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 7 ;
            frames = FRAMES ;
         }
         break ;
      case 7 :
         l_upleg_dif = -25 ;
         r_upleg_dif = 5 ;
         l_loleg_dif = -40 ;
         r_loleg_dif = 10 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

         walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  += r_upleg_add ;
         langle_count2 += r_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 8 ;
            frames = FRAMES ;
         }
         break ;
      case 8 :
         l_upleg_dif = 25 ;
         r_upleg_dif = 20 ;
         l_loleg_dif = -50 ;
         r_loleg_dif = -10 ;

         l_upleg_add = l_upleg_dif / FRAMES ;
       	r_upleg_add = r_upleg_dif / FRAMES ;
         l_loleg_add = l_loleg_dif / FRAMES ;
       	r_loleg_add = r_loleg_dif / FRAMES ;

         walking_angles[0][3] += r_upleg_add ;
   		walking_angles[1][3] += l_upleg_add ;
       	walking_angles[0][4] += r_loleg_add ;
   		walking_angles[1][4] += l_loleg_add ;

         langle_count  += r_upleg_add ;
         langle_count2 += r_loleg_add ;
   		rangle_count -= r_upleg_add ;
         rangle_count2 -= r_loleg_add ;
   		base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count2 ) ;
         frames-- ;
         if (frames == 0)
         {
            flag = 1 ;
            frames = FRAMES ;
         }
         break ;
      default :
         break ;
   }

   if (zoom_flag)
   {
   	switch (zoom_fl)
   	{
      	case 0 :
         	zoom += 0.05 ;
         	if (zoom > 2.5) zoom_fl = 1 ;
         	break ;
      	case 1 :
         	zoom -= 0.05 ;
         	if (zoom < -2.5) zoom_fl = 0 ;
         	break ;
      	default :
         	break ;
   	}
   }

   if (rotate_flag)
   {
      rotate = (rotate + 1) % 360 ;
   }
   glutPostRedisplay() ;
}

void mudaDirecaoPerna(void)
{
/*	if (mudaDirecaoEsquerda)
   {
		glRotatef(50.0,0.0,1.0,0.0) ;
		//mudaDirecaoEsquerda = !mudaDirecaoEsquerda ;
   }
   if (mudaDirecaoDireita)
   {
		glRotatef(-50.0,0.0,1.0,0.0) ;
		//mudaDirecaoDireita = !mudaDirecaoDireita ;
   }
   */
   glRotatef(rotateLeg,0.0,1.0,0.0) ;
}

void Draw_Monstrengo(int frame)
{
    glTranslatef(0.0,base_move,0.0) ;
	Draw_Cannon(frame);
	glTranslatef(0.0,-0.35,0.0) ;
   	Draw_Base_Legs(frame) ;
}

void Draw_Base_Legs(int frame)
{
   
   glPushMatrix() ;
    //glTranslatef(0.0,base_move,0.0) ;
	/*glPushMatrix() ;
		mudaDirecao() ;
		Draw_Cannon(WIRE);
	glPopMatrix() ;*/
    //glTranslatef(0.0,-0.6,0.0) ;
    Draw_Base(frame) ;
    glTranslatef(0.0,-(BASE_HEIGHT),TORSO+0.8) ;
    mudaDirecaoPerna() ;
    glPushMatrix() ;
     glTranslatef(TORSO_WIDTH * 0.33,0.0,0.0) ;
     Draw_Leg(LEFT,frame) ;
    glPopMatrix() ;
     glTranslatef(-TORSO_WIDTH * 0.33,0.0,0.0) ;
    Draw_Leg(RIGHT,frame) ;
    glPopMatrix() ;
    glTranslatef(0.0,-(BASE_HEIGHT),TORSO-1.2) ;
    mudaDirecaoPerna() ;
	glPushMatrix() ;
     glTranslatef(TORSO_WIDTH * 0.33,0.0,0.0) ;
     Draw_Leg(LEFT,frame) ;
    glPopMatrix() ;
    glTranslatef(-TORSO_WIDTH * 0.33,0.0,0.0) ;
    Draw_Leg(RIGHT,frame) ;
   glPopMatrix() ;
}


//================= Base(frame) ======================

void Draw_Base(int frame)
{
	glPushMatrix() ;
   glScalef(BASE_WIDTH, BASE_HEIGHT, TORSO+2) ;
   //glTranslatef(0.0,0.0,TORSO-1.35) ;
   glColor3f(0.0,1.0,1.0) ;
   if (frame == WIRE)
      glutWireCube(1.0) ;
   else
      glutSolidCube(1.0) ;
   glPopMatrix() ;
}

void Draw_Upper_Leg(int frame)
{
   glPushMatrix() ;
   glScalef(UP_LEG_JOINT_SIZE, UP_LEG_JOINT_SIZE, UP_LEG_JOINT_SIZE) ;
   glColor3f(0.0,1.0,0.0) ;
   if (frame == WIRE)
   	glutWireSphere(1.0,8,8) ;
   else
   	glutSolidSphere(1.0,8,8) ;
   glPopMatrix() ;
   glColor3f(0.0,0.0,1.0) ;
   glTranslatef(0.0,- UP_LEG_HEIGHT * 0.75, 0.0) ;
   glPushMatrix() ;
   glScalef(UP_LEG_WIDTH,UP_LEG_HEIGHT,UP_LEG_WIDTH) ;
   if (frame == WIRE)
   	glutWireCube(1.0) ;
   else
      glutSolidCube(1.0) ;
   glPopMatrix() ;
}

void Draw_Lower_Leg(int frame)
{
   glPushMatrix() ;
   glScalef(LO_LEG_JOINT_SIZE,LO_LEG_JOINT_SIZE,LO_LEG_JOINT_SIZE) ;
   glColor3f(0.0,1.0,0.0) ;
   if (frame == WIRE)
   	glutWireSphere(1.0,8,8) ;
   else
      glutSolidSphere(1.0,8,8) ;
   glPopMatrix() ;
   glTranslatef(0.0,- LO_LEG_HEIGHT * 0.75,0.0) ;
   glPushMatrix() ;
   glScalef(LO_LEG_WIDTH,LO_LEG_HEIGHT,LO_LEG_WIDTH) ;
   glColor3f(0.0,0.0,1.0) ;
   if (frame == WIRE)
   	glutWireCube(1.0) ;
   else
      glutSolidCube(1.0) ;
   glPopMatrix() ;
}

void Draw_Foot(int frame)
{
   glPushMatrix() ;
   glScalef(FOOT_JOINT_SIZE,FOOT_JOINT_SIZE,FOOT_JOINT_SIZE) ;
   glColor3f(0.0,1.0,0.0) ;
   if (frame == WIRE)
   	glutWireCube(1.0) ;
   else
      glutSolidCube(1.0) ;
   glPopMatrix() ;
   glTranslatef(0.0,- FOOT_JOINT_SIZE * 2.0, FOOT_WIDTH * 0.5) ;
   glPushMatrix() ;
   glScalef(FOOT_WIDTH, FOOT_HEIGHT, FOOT) ;
   glColor3f(0.0,0.0,1.0) ;
   if (frame == WIRE)
   	glutWireCube(1.0) ;
   else
      glutSolidCube(1.0) ;
   glPopMatrix() ;
}

void Draw_Leg(int side, int frame)
{
   
   glPushMatrix() ;
//   mudaDirecao ;
   glRotatef(walking_angles[side][3],1.0,0.0,0.0) ;
   Draw_Upper_Leg(frame) ;
   glTranslatef(0.0,- UP_LEG_HEIGHT * 0.75,0.0) ;
   glRotatef(walking_angles[side][4],1.0,0.0,0.0) ;
   Draw_Lower_Leg(frame) ;
   glTranslatef(0.0,- LO_LEG_HEIGHT * 0.625, 0.0) ;
   glRotatef(walking_angles[side][5],1.0,0.0,0.0) ;
   Draw_Foot(frame) ;
   glPopMatrix() ;
}


void Draw_Pipe(int frame)
{
	int i;

	glPushMatrix() ;
	glColor3f(1.0,0.0,1.0) ;
	glTranslatef(0.35,0.0,0.0);
	for (i=0; i<=3; i++)
	{
		if (frame == WIRE)
   			glutWireCube(0.2) ;
		else
   			glutSolidCube(0.2) ;
		glTranslatef(0.2,0.0,0.0);
	};
	if (atirou == 1) 
	{
		glTranslatef(25,0.0,0.0);
		glScalef(50, 0.2, 0.2) ;
		glColor3f(1.0,1.0,1.0) ;
		if (frame == WIRE)
   			glutWireCube(1.0) ;
		else
			glutSolidCube(1.0) ;
		atirou = 2;
	}

	glPopMatrix() ;
}

void Draw_Cannon(int frame)
{
	glPushMatrix() ;
	glRotatef(rotateCannon, 0.0,1.0,0.0);
    glColor3f(0.0,1.0,0.0) ;
	glBlendFunc(1.0,GL_ONE);               
	if (frame == WIRE)
	{

/*		glEnable(GL_LIGHTING);
		glLightfv(GL_LIGHT0, GL_AMBIENT, LightDiffuse);
		glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);
		glLightfv(GL_LIGHT0, GL_EMISSION, emissiveLight);
		glEnable(GL_LIGHT0);
*/
   		glutWireCube(0.5) ;
	}
	else
	{
/*		glEnable(GL_COLOR_MATERIAL);
		glEnable(GL_LIGHTING);
		glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
		glLightfv(GL_LIGHT0, GL_SPECULAR, LightDiffuse);
		glLightfv(GL_LIGHT0, GL_POSITION, LightPosition);
		glEnable(GL_LIGHT0); 
*/
   		glutSolidCube(0.5) ;
/*
		glDisable(GL_LIGHT0); 
		glDisable(GL_LIGHTING); 
		glDisable(GL_COLOR_MATERIAL);
*/	}
	Draw_Pipe(frame);
	glPopMatrix() ;

}