#ifndef MODEL
#define MODEL

#ifdef __FLAT__
#include <windows.h>
#endif
#include <gl/glut.h>
#include <stdio.h>
#include <math.h>

#ifndef PI
#define PI 3.1415
#endif

#define FOOT_JOINT_SIZE       HEAD_JOINT_SIZE
#define FOOT_HEIGHT           FOOT_JOINT_SIZE * 2.0
#define FOOT_WIDTH            LO_LEG_WIDTH
#define FOOT						FOOT_WIDTH * 2.0
#define UP_ARM_HEIGHT         TORSO_HEIGHT * 0.625
#define UP_ARM_WIDTH          TORSO_WIDTH/4.0
#define UP_ARM_JOINT_SIZE     HEAD_JOINT_SIZE * 2.0
#define LO_ARM_HEIGHT         TORSO_HEIGHT * 0.5
#define LO_ARM_WIDTH          UP_ARM_WIDTH
#define LO_ARM_JOINT_SIZE     UP_ARM_JOINT_SIZE * 0.75
#define HAND_HEIGHT           LO_ARM_HEIGHT / 2.0
#define HAND_WIDTH            LO_ARM_WIDTH
#define HAND                  LO_ARM_WIDTH / 2.0
#define FINGER_SIZE           0.1
#define TORSO_WIDTH           TORSO_HEIGHT * 0.75
#define TORSO_HEIGHT          0.8
#define TORSO                 TORSO_WIDTH / 3.0
#define HEAD_WIDTH            HEAD_HEIGHT * 0.93
#define HEAD_HEIGHT 				TORSO_HEIGHT * 0.375
#define HEAD_JOINT_SIZE       HEAD_HEIGHT/6
#define BASE_WIDTH            TORSO_WIDTH
#define BASE_HEIGHT           TORSO_HEIGHT / 4.0
#define UP_LEG_HEIGHT         LO_ARM_HEIGHT
#define UP_LEG_JOINT_SIZE     UP_ARM_JOINT_SIZE
#define UP_LEG_WIDTH          UP_LEG_JOINT_SIZE * 2.0
#define LO_LEG_HEIGHT         UP_LEG_HEIGHT
#define LO_LEG_WIDTH          UP_LEG_WIDTH
#define LO_LEG_JOINT_SIZE     UP_LEG_JOINT_SIZE
#define LEG_HEIGHT            UP_LEG_HEIGHT + LO_LEG_HEIGHT + FOOT_HEIGHT + 2*(FOOT_JOINT_SIZE+UP_LEG_JOINT_SIZE+LO_LEG_JOINT_SIZE)

#define FRAMES 20

#define SOLID 1
#define WIRE  2

#define LEFT  0
#define RIGHT 1

extern float walking_angles[2][6]  ;
extern double base_move ;

extern float langle_count ;
extern float langle_count2 ;
extern float rangle_count ;
extern float rangle_count2 ;

extern float zoom ;
extern int zoom_flag ;
extern int rotate_flag ;
extern int rotate ;
extern int mudaDirecaoEsquerda ;
extern int mudaDirecaoDireita ;
extern int rotateLeg ;
extern int rotateCannon ;
extern int rotateV;
extern GLfloat LightAmbient[];
extern GLfloat LightPosition[];
extern GLfloat LightDiffuse[];
extern GLuint	texture[1];
extern GLfloat	emissiveLight[];
extern int atirou;


double find_base_move(double angle_up, double angle_lo, double up, double lo) ;

void animate(void) ;

void animate_base(void) ;

void Draw_Base_Legs(int frame) ;

void Draw_Base(int frame) ;

void Draw_Leg(int side,int frame) ;

void Draw_Cannon(int frame);

void Draw_Monstrengo(int frame);

#endif
